
%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../main"
%%% End:

\section{Varying number of arguments}

\subsection{Status}

This issue has been resolved, although if there is still enough
space in the opcode map, we may revisit the issue with regards
to making the instruction set more space efficient.

\subsection{Context}

The main issues with varying arguments in a stack machine are:

\begin{itemize}
\item If the argument count is taken from the stack,
  it may be difficult to detect an error where one forgets
  to provide the argument count and the arguments to the message
  themselves are also integers. The implementation then is also
  unsure of how much stack each message consumes.

\item If the selector is taken from the stack,
  you end up with a situation similar to the usage of \emph{funcall}
  in a lisp-2, except for every method invocation. This may not be desirable
  in the event a selector is accidentally provided dynamically, although
  this would be more obvious as a \emph{literal} operation would
  not precede the message send.

\item If argument count is not provided with every \emph{send}
  instruction and only for methods with varying number of arguments,
  message transparency may be disrupted as argument
  parsing code might be changed between method implementations.

\item If argument count is provided with every \emph{send}
  then we potentially use up a lot more bytes than
  if variable number of arguments were not supported.

\item An argument count is necessary for the implementation to ensure
  that a message accepts the same number of arguments that has been
  explicitly provided by the caller and not any more. This otherwise
  would be an exploit whereby messages could take objects that
  were not meant for them and even silently by then replacing
  them onto the stack.
\end{itemize}

\subsection{Possible solutions}
\subsubsection{An extra operand for argument count}

Send and Implicit Self Send take a third byte that
is the argument count

A prefix instruction is also provided to override the semantics
of Send and Implicit Self Send to provide both the selector
and argument count from the stack instead.

\begin{itemize}
\item Send (selector-index) (argument-count one additional byte)
\item Implicit Self Send (selector-index)
  (argument-count one additional byte)
\item Applying Send (Send Type) (argument-count)
  \begin{sloppypar}
    Override the next instance of Send or Implicit Self send to
    take the message selector from the stack and a minimum of
    one arguments, the final one being a sequence of
    additional arguments to the message.
    The low nibble of the opcodes of both send instructions
    would need to be ignored and the next byte would be the
    argument-count. Rather than being a prefix this could
    also just be provided as two additional instructions.
  \end{sloppypar}
\end{itemize}

\subsubsection{Selector on the stack, argument count in the operand}

The operand of the send instructions are the number of arguments
to remove from the stack in addition to consuming a selector
from the stack.

A modifier prefix is provided to override the behaviour of both
send and implicit-self-send instructions to accept a linear sequence
for arguments that are constructed dynamically similar to Common
Lisp's apply.

Argument count is always provided.